Subject: Re: bug#29785: [PATCH] Implement separate eww history

From: Robert Pluim <[email-masked]>
Date: Wed, 20 Dec 2017 18:27:57 +0100

Eli Zaretskii <[email-masked]> writes:

>> From: Robert Pluim <[email-masked]>
>> Cc: [email-masked]
>> Date: Wed, 20 Dec 2017 17:36:58 +0100
>> 
>> Eli Zaretskii <[email-masked]> writes:
>> 
>> > Why should EWW usurp the history of URLs?
>> 
>> The patch does not change the existing history support of browse-url,
>> so 'usurp' feels harsh.
>
> It's just a word.  It feels strange to me to call URL history by name
> that includes "eww" as a substring.  IMO it should be a general URL
> history, like we have for files.
>

It's the url history of M-x eww, but it's just a name.

> But that's just one opinion.
>
>> I could make the argument that URLs visited via browse-url are
>> passed to an external browser, so it's not up to Emacs to remember
>> that history, unlike ones visited internally using EWW.
>
> url-history.el seems to disagree.

OK, so that does even more, it remembers url history across
sessions. I never noticed it because:

a) It's disabled by default.

b) As far as I can tell, nothing uses it for actual completion of
urls.

So the final implementation should

1. Enable it by default
2. Hook up eww to it
3. Hook up browse-url to it
4. and probably various things in org

Note that eww has a separate history mechanism also to track the urls
you visit during a session (there may be a way to persist that as
well).

I'm thinking 3 different history mechanisms is too much. I can work on
connecting at least eww to the existing url-history mechanism over the
holidays, if you think that's the right direction [1]

> Thanks.  In many cases, like this one, it's very simple:
>
>   *** New user variable 'eww-separate-history'.
>   If non-nil, this causes EWW to use a separate minibuffer history.
>   The default is nil.

Thanks for that.

Robert

Footnotes: 
[1] And if I really get going I'll try to unify the 4 different ways
we have of determining what URL we think is at point